class AddForumToUsers < ActiveRecord::Migration

  def change
    #_____________________________________forum  users______________________________________________________#

    add_column  Xforum.user_table.to_sym, :forum_posting_privileges,        :boolean, default:true
    add_column  Xforum.user_table.to_sym, :forum_reading_privileges,        :boolean, default:true
    add_column  Xforum.user_table.to_sym, :forum_admin,                     :boolean, default:false
    add_column  Xforum.user_table.to_sym, :forum_translating_privileges,    :boolean, default:true
    add_column  Xforum.user_table.to_sym, :forum_post_name,                 :string
    add_index   Xforum.user_table.to_sym, :forum_post_name,                 name: "index_#{Xforum.user_table}_on_forum_post_name".to_sym
    add_index   Xforum.user_table.to_sym, :forum_posting_privileges,        name: "index_#{Xforum.user_table}_on_forum_posting_privileges".to_sym
    add_index   Xforum.user_table.to_sym, :forum_reading_privileges,        name: "index_#{Xforum.user_table}_on_forum_reading_privileges".to_sym
    add_index   Xforum.user_table.to_sym, :forum_translating_privileges,    name: "index_#{Xforum.user_table}_on_forum_translating_privileges".to_sym
    add_index   Xforum.user_table.to_sym, :forum_admin,                     name: "index_#{Xforum.user_table}_on_forum_admin".to_sym

    #_______________________________________________________________________________________________________#

  end
end