jQuery ->
  $('#gotoforum').click ->
    startForum()
  $('#gotoforumpage').click ->
    startForum()
  $('#close-forum').click ->
    closeForum()
  $('#forum-senate').delegate 'img[id = forum-photo]','click', (evt) ->
    playPhoto(event.target)
  $('#forum-senate').delegate 'img[id = forum-photo]','mouseenter', (evt) ->
    makePhotoBig(event.target,true)
  $('#forum-senate').delegate 'img[id = forum-photo]','mouseleave', (evt) ->
    makePhotoBig(event.target,false)
  $('#forum-senate').delegate 'img[id = forum-photo]','dblclick', (evt) ->
    runPhotoGallery(event.target)
  $('#forum-topic').change ->
    getSenate()
  $('#forum-language').change ->
    getSenate()
  $('#forum-category').change ->
    changeTopic()
  $('#forum-video-replay').click ->
    img=document.getElementById('big-forum-picture')
    img.src=img.src
  $('#forum-video-back').click ->
    goBackToSenate()

goBackToSenate=->
  hideMe({id:'forum-senate-video'})
  showForumElements()
  showMe({id:'forum-senate'})

runPhotoGallery=(target)->
  hideMe({id:'forum-senate'})
  showMe({id:'forum-senate-video'})
  console.log('target.video  ' + target.dataset.video)
  if target.dataset.video=='true'
    getTheVideo(target)
  else
    showMe({id:'big-forum-picture-span'})
    img=document.getElementById('big-forum-picture')
    img.src=target.src
  hideForumElements()


getTheVideo=(photo)->
  console.log('in get video')
  showMe({id:'big-forum-video-span'})
  hideMe({id:'big-forum-picture-span'})
  forumWait()
  $.post('xforum/forum_ajax',{function:'get video',forum_id:photo.dataset.forum_id},playVideo)

playVideo=(params)->
  video=document.getElementById('big-forum-video')
  video.src=params.video
  video.canplay=forumGo()


window.startForum = ->
  window.forum_user_emails=[]
  window.forum_user_names=[]
  window.forum_user_email_ids=[]
  window.forum_user_name_ids=[]

  hideMe({id: showPageName()})
  showForumElements()
  pages=  document.getElementById('xforum-help-pages')
  if pages?
    document.getElementById('forum-box').appendChild(pages);
  blockMe({id: 'forum-page'})
  clearSenate()
  showMe({id:'forum-category'})
  $.post('xforum/forum_ajax', {function: 'get topics', category: 'select category', hold_test: true, restricted: true},loadList)
  comment_span = document.getElementById('forum-comment-span')
  comment_span.dataset.translating == 'false'
  hideMe({obj: comment_span})
  $.post('xforum/forum_ajax', {function:'categories', language: getLanguage(),list:'forum-category', hold_test: true, restricted: true},loadList)
  $.post('xforum/forum_ajax', {function:'categories', language: getLanguage(),list:'forum-category-admin', hold_test: false, restricted: false},loadList)
  $.post('xforum/forum_ajax', {function:'categories', language: getLanguage(),list:'forum-category-monitor', hold_test: false, restricted: false},loadList)
  $.post('xforum/forum_ajax',{function:'get language set',list:'forum-language',active:true,by_name:false},loadList)
  $.post('xforum/forum_ajax',{function:'get language set',list:'forum-translation-language',short:true,active:true},loadCustomList)
  $.post('xforum/forum_ajax',{function:'get language set',list:'forum-translation-language',short:false,active:true},loadList)

closeForum = ->
  hideMe({id: 'forum-page'})
  blockMe({id: showPageName()})
  clearSenate()
  setCategory(0)
  setTopic(0)
  changeTopic()
  cancelComment()
  $('#forum-comment').val('')
  if $('#comment-maybe')?
    $('#comment-maybe').remove()
  hideMe({id: 'comment-span'})
  hideMe({id: 'forum-senate-admin-lists'})
  hideMe({id: "forum-senate-admin-users"})
  blockMe({id: 'forum-senate'})

window.showForumElements=->
  showMe({id:'forum-topic'})
  showMe({name:'review-forum'})
  showMe({id:'forum-language'})
  showMe({name:'forum-subscribe'})
  showMe({id:'forum-category'})

window.hideForumElements=->
  hideMe({id:'forum-topic'})
  hideMe({name:'review-forum'})
  hideMe({id:'forum-language'})
  hideMe({name:'forum-subscribe'})
  hideMe({id:'forum-category'})

loadCustomList=(params)->
  if params? && params.list_data?  && params.list_data.length>0
    list_data = params.list_data
    selector = document.getElementById('forum-translation-choices')
    $(selector).children().remove()
    for i in [0...list_data.length]
      option = document.createElement('LI')
      option.dataset.choice = list_data[i].item
      option.dataset.display= list_data[i].value
      option.innerHTML=list_data[i].value
      selector.appendChild(option)
      option.id='forum-translation-choice'
      option.classList.add('drop-menu')

window.loadList = (params)->
  loadListData(params,false)

window.loadListPlus = (params)->
  loadListData(params,true)

window.loadListData=(params,global) ->
  if params? && params.list_data?
    list_data = params.list_data
    if params.name != undefined
      selector= $("[name="+params.name+"]")
    else if params.id !=undefined
      selector = $(document.getElementById(params.id))
    else if params.obj !=undefined
      selector=$(params.obj)
    selector.children().remove()
    switch selector[0].name
      when 'forum-user-emails'
        g_list=forum_user_emails
        g_list_ids=forum_user_email_ids;
      when 'forum-user-names'
        g_list=forum_user_names
        g_list_ids=forum_user_name_ids
      else
    if list_data.length==0
      hideMe({obj:selector})
    else
      for i in [0...list_data.length]
        unless list_data[i].state == 'closed'
          pushOption(selector,list_data[i], 0)
          if global
            g_list.push(list_data[i].value)
            g_list_ids.push(list_data[i].item)

window.pushOption = (q_selector,data,offset)->
  selector=q_selector.get()[0]
  if selector?
    switch selector.tagName
      when 'UL'
        option= document.createElement('li')
        option.innerHTML=data.value
      when 'SELECT'
        option = document.createElement("option")
        option.text = data.value
      else
    option.value = data.item
    option.id =  'forum-admin-list-option'
    ref = selector.children[selector.children.length - offset]
    if ref==undefined
      selector.appendChild(option)
    else
      selector.insertBefore(option,ref)
  else
    alert "#{q_selector}  is not there"


window.getLanguage = ->
  getSelectValues({id:'forum-language', ref:true})

window.getTopic = ->
  document.getElementById('forum-topic').value

window.getCategory = ->
  document.getElementById('forum-category').value

window.setTopic = (index)->
  topic = $('select[id = forum-topic]').get()[0]
  topic.selectedIndex= index

window.setCategory = (index)->
  category = $('select[id = forum-category]').get()[0]
  category.selectedIndex= index

window.clearSenate = ->
  children = $('#just-a-comment')
  if children?
    $('span[id = just-a-comment]').remove()
  senate= document.getElementById('forum-senate')
  help_page= senate.dataset.helppage
  if help_page?
    hideMe({id:help_page})
  deleteMyData(senate)
  hideMe({id: 'forum-voting-booth'})
  hideMe({id: 'subscribe-forum'})
  hideMe({id: 'unsubscribe-forum'})
  hideMe({id: 'forum-add-new-thing-span'})
  hideMe({id: 'forum-senate-admin'})
  document.getElementById('forum-senate').dataset.admining = 'false'

window.setSenate = (params)->
  page = document.getElementById('forum-senate')
  blockMe({id:'forum-senate'})
  document.getElementById('forum-comment-span').dataset.next_id = params.index
  kids = $(page).children()
  unless !params.the_list?
    for i in [0...kids.length]
      unless kids[i].id == 'forum-comment-span'
        removeMe({obj:kids[i]})
    unless params.the_list.length == 0
      if params.the_list[0].content.search('@show@page@')>=0
        showHelpPage(params.the_list[0].content)
      else
        for i in [0...params.the_list.length]
          buildSpan(page, i, params.the_list[i])

showHelpPage=(page)->
  help_page=page.replace('@show@page@','').trim()
  senate=document.getElementById('forum-senate')
  senate.dataset.helppage=help_page
  hideMe({id:'forum-senate'})
  blockMe({id:help_page})

buildSpan = (page, index, params) ->
  span = document.createElement('span')
  if index == 0
    span.classList.add('forum-topic' )
    span.dataset.indent=0
    page.dataset.moderator = params.moderator
    if params.moderator then $.post('xforum/forum_ajax',{function:'get translations',topic:getTopic(),language:getTranslationLanguage()},saveTranslationSuggestions)
    if params.subscribed? then setSubscriber(params.subscribed)
    if params.vote then  setUpVoting({vote: params.vote, votes: params.votes})
    if params.moderator then showMe({id: 'review-forum-span'})
    if params.review then page.dataset.review = true
    if params.admin then page.dataset.admin=true
  else  span.className = "forum-comment"
  span.id = "just-a-comment"
  indexes=Object.keys(params)
  for k in [0...indexes.length]
    unless indexes[k]=='empty_list'
      span.dataset[indexes[k]]=params[indexes[k]]
  the_list=JSON.parse(params.empty_list)
  span.dataset.needy_list= JSON.stringify(the_list)  #convert to javascript friendly JSON
  if page.dataset.moderator == 'true' && params.comment_state == 'new'
    da_class = 'forum-comment-new'
  else if page.dataset.moderator == 'true' && params.comment_state == 'reject'
    da_class = 'forum-comment-reject'
  else if params.needs_translation
    da_class = 'forum-comment-translate'
  else
    da_class = 'forum-comment'
  the_comment=params.content.replace('::',':<br>')
  span.innerHTML = '<p>' + the_comment + '</p>'
  page.appendChild(span)
  paragraph=span.getElementsByTagName('p')[0]
  paragraph.classList.add(da_class)
  paragraph.style.marginLeft = "#{params.indent * 20}px"       #why doesn't this make it out
  putOwnerIn(span,params)
  if params.has_photo
    putPhotosIn(span,params.photos.urls,params.photos.video,params.photos.forum)
  if params.hyperlinks?
    hyperlinks=params.hyperlinks
    for i in [0...hyperlinks.length]
      writeLink(hyperlinks[i],span)


window.getSelectedId = ->
  if  window.getSelection != undefined
    sel = window.getSelection()
    unless sel== null
      span = sel.anchorNode.parentNode.parentElement
      if sel.rangeCount
        container = document.createElement("div")
        for  i in [0...sel.rangeCount]
          container.appendChild(sel.getRangeAt(i).cloneContents())
        html = container.innerHTML
  else if  document.selection != undefined
    if (document.selection.type == "Text")
      html = document.selection.createRange().htmlText
  unless span?
    spans = $('#forum-senate-span')
    if spans.length > 0
      span = spans[spans.length - 1]
  {selection: html, id: span.dataset.id}

putPhotosIn=(span,urls,video,forum_id)->
  console.log('photo ', video)
  span.dataset.already_has_photo=true
  lineReturn=document.createElement('span')
  lineReturn.innerHTML='<br>'
  paragraph=span.getElementsByTagName('p')[0]
  paragraph.appendChild(lineReturn)
  for i in [0...urls.length]
    img= new Image
    img.src=urls[i]
    img.className= 'forum-photo'
    img.id='forum-photo'
    img.dataset.index=i
    img.dataset.forum_id=forum_id
    if video
      img.dataset.video=true
    paragraph.appendChild(img)

window.putOwnerIn=(span,params)->
  paragraph=span.getElementsByTagName('p')[0]
  newspan= document.createElement('span')
  newspan.innerHTML = params.owner_name
  newspan.classList.add('right')
  newspan.style.position='relative'
  paragraph.appendChild(newspan)

makePhotoBig=(photo,bigger)->
  if bigger
    photo.classList.add('forum-big-photo')
    photo.classList.remove('forum-photo')
  else
    photo.classList.remove('forum-big-photo')
    photo.classList.add('forum-photo')

activatePhoto=->
  photos=$('[data-hold_tight=true]')
  for i in [0...photos.length]
    photos[i].dataset.free_photo = true

playPhoto=(photo)->
  photo.src=photo.src
  event.stopPropagation()

askForPhotAgain=(params)->
  $.post('xforum/forum_ajax',{function:'get forum photo',tag:params.tag,edit:params.edit,count:params.count,id:params.id,parent:params.parent},needAPhoto)

window.needAPhoto=(params)->
  if params.urls.length > 0
    setMaybeId(params)
    if params.edit=='true'
      span=$('[data-id='+params.id+']').get()[0]
    else
      span=$("[data-tag=#{params.tag}]").get()[0]
    putPhotosIn(span,params.urls)
  else #if params.count < 20
    setTimeout (-> askForPhotAgain(params)), 2000

getSenate = ->
  clearSenate()
  select = document.getElementById('forum-topic').value
  if select == 'request new topic'
    addNewThing({'forum-topic'})
  else
    document.getElementById('forum-senate').dataset.topic = select
    $.post('xforum/forum_ajax', {function: 'get senate',language:getLanguage(), topic: select}, setSenate)

addNewThing = (select)->
  $('#add-new-thing-input').val('')
  showMe({id: 'forum-add-new-thing-span'})
  hideMe({id: 'forum-senate'})
  $('#forum-add-new-thing-span').data.thing = select

window.changeTopic = ->
  setTopic(0)
  select = document.getElementById('forum-category').value
  hideMe({id: 'forum-senate-admin-lists'})
  hideMe({id:'forum-senate-admin-users'})
  clearSenate()
  if select == 'request new category'
    addNewThing('forum-category')
  else if select == 'admin'
    doAdminStuff()
  else if select != 'select category'
    blockMe({id: 'forum-senate'})
    hideMe({id: 'forum-senate-admin'})
    document.getElementById('forum-senate').dataset.category = select
    $.post('xforum/forum_ajax', {function: 'get topics',list:'forum-topic', category: select, hold_test: true, restricted: true}, loadList)

